
// This file was automatically generated by the PetaPoco T4 Template
// Do not make changes directly to this file - edit the template instead
// 
// The following connection settings were used to generate this file
// 
//     Connection String Name: `dbconnection`
//     Provider:               `System.Data.SqlClient`
//     Connection String:      `Data Source=(localdb)\MSSQLLocalDB;Initial Catalog=Bancolombia_MDT_Tracking;Connection Timeout=0`
//     Schema:                 ``
//     Include Views:          `False`

using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using PetaPoco;

namespace dbconnection
{
	public partial class dbconnectionDB : Database
	{
		public dbconnectionDB() 
			: base("dbconnection")
		{
			CommonConstruct();
		}

		public dbconnectionDB(string connectionStringName) 
			: base(connectionStringName)
		{
			CommonConstruct();
		}
		
		partial void CommonConstruct();
		
		public interface IFactory
		{
			dbconnectionDB GetInstance();
		}
		
		public static IFactory Factory { get; set; }
        public static dbconnectionDB GetInstance()
        {
			if (_instance!=null)
				return _instance;
				
			if (Factory!=null)
				return Factory.GetInstance();
			else
				return new dbconnectionDB();
        }

		[ThreadStatic] static dbconnectionDB _instance;
		
		public override void OnBeginTransaction()
		{
			if (_instance==null)
				_instance=this;
		}
		
		public override void OnEndTransaction()
		{
			if (_instance==this)
				_instance=null;
		}
        
		public class Record<T> where T:new()
		{
			public static dbconnectionDB repo { get { return dbconnectionDB.GetInstance(); } }
			public bool IsNew() { return repo.IsNew(this); }
			public object Insert() { return repo.Insert(this); }
			public void Save() { repo.Save(this); }
			public int Update() { return repo.Update(this); }
			public int Update(IEnumerable<string> columns) { return repo.Update(this, columns); }
			public static int Update(string sql, params object[] args) { return repo.Update<T>(sql, args); }
			public static int Update(Sql sql) { return repo.Update<T>(sql); }
			public int Delete() { return repo.Delete(this); }
			public static int Delete(string sql, params object[] args) { return repo.Delete<T>(sql, args); }
			public static int Delete(Sql sql) { return repo.Delete<T>(sql); }
			public static int Delete(object primaryKey) { return repo.Delete<T>(primaryKey); }
			public static bool Exists(object primaryKey) { return repo.Exists<T>(primaryKey); }
			public static bool Exists(string sql, params object[] args) { return repo.Exists<T>(sql, args); }
			public static T SingleOrDefault(object primaryKey) { return repo.SingleOrDefault<T>(primaryKey); }
			public static T SingleOrDefault(string sql, params object[] args) { return repo.SingleOrDefault<T>(sql, args); }
			public static T SingleOrDefault(Sql sql) { return repo.SingleOrDefault<T>(sql); }
			public static T FirstOrDefault(string sql, params object[] args) { return repo.FirstOrDefault<T>(sql, args); }
			public static T FirstOrDefault(Sql sql) { return repo.FirstOrDefault<T>(sql); }
			public static T Single(object primaryKey) { return repo.Single<T>(primaryKey); }
			public static T Single(string sql, params object[] args) { return repo.Single<T>(sql, args); }
			public static T Single(Sql sql) { return repo.Single<T>(sql); }
			public static T First(string sql, params object[] args) { return repo.First<T>(sql, args); }
			public static T First(Sql sql) { return repo.First<T>(sql); }
			public static List<T> Fetch(string sql, params object[] args) { return repo.Fetch<T>(sql, args); }
			public static List<T> Fetch(Sql sql) { return repo.Fetch<T>(sql); }
			public static List<T> Fetch(long page, long itemsPerPage, string sql, params object[] args) { return repo.Fetch<T>(page, itemsPerPage, sql, args); }
			public static List<T> Fetch(long page, long itemsPerPage, Sql sql) { return repo.Fetch<T>(page, itemsPerPage, sql); }
			public static List<T> SkipTake(long skip, long take, string sql, params object[] args) { return repo.SkipTake<T>(skip, take, sql, args); }
			public static List<T> SkipTake(long skip, long take, Sql sql) { return repo.SkipTake<T>(skip, take, sql); }
			public static Page<T> Page(long page, long itemsPerPage, string sql, params object[] args) { return repo.Page<T>(page, itemsPerPage, sql, args); }
			public static Page<T> Page(long page, long itemsPerPage, Sql sql) { return repo.Page<T>(page, itemsPerPage, sql); }
			public static IEnumerable<T> Query(string sql, params object[] args) { return repo.Query<T>(sql, args); }
			public static IEnumerable<T> Query(Sql sql) { return repo.Query<T>(sql); }
		}
	}
	

    
	[TableName("dbo.Batches")]
	[PrimaryKey("BatchID")]
	[ExplicitColumns]
    public partial class Batch : dbconnectionDB.Record<Batch>  
    {
		[Column] public long BatchID { get; set; }
		[Column] public long PID { get; set; }
		[Column] public string Tula { get; set; }
		[Column] public string BatchName { get; set; }
		[Column] public string KofaxReady { get; set; }
		[Column] public bool Available { get; set; }
		[Column] public string SiteName { get; set; }
		[Column] public DateTime? CheckInDateTime { get; set; }
		[Column] public DateTime? CheckoutDateTime { get; set; }
	}
    
	[TableName("dbo.Boxes")]
	[PrimaryKey("BoxId")]
	[ExplicitColumns]
    public partial class Box : dbconnectionDB.Record<Box>  
    {
		[Column] public long BoxId { get; set; }
		[Column] public string Name { get; set; }
		[Column] public string ProcessType { get; set; }
		[Column] public bool Available { get; set; }
		[Column] public bool Status { get; set; }
		[Column] public long? UserId { get; set; }
		[Column] public long? NumberCount { get; set; }
		[Column] public string Site { get; set; }
	}
    
	[TableName("dbo.Holidays_Bancolombia")]
	[ExplicitColumns]
    public partial class Holidays_Bancolombium : dbconnectionDB.Record<Holidays_Bancolombium>  
    {
		[Column] public DateTime HD_Date { get; set; }
	}
    
	[TableName("dbo.PIDs")]
	[PrimaryKey("PIDID")]
	[ExplicitColumns]
    public partial class PID : dbconnectionDB.Record<PID>  
    {
		[Column] public long PIDID { get; set; }
		[Column] public string Tula { get; set; }
		[Column] public int? BatchCount { get; set; }
		[Column] public DateTime ReceivedDateTime { get; set; }
		[Column] public DateTime ManifestDateTime { get; set; }
		[Column] public DateTime? ClosedDateTime { get; set; }
		[Column] public long UserID { get; set; }
		[Column] public bool Available { get; set; }
		[Column] public int? TIDCount { get; set; }
		[Column] public bool IsCanje { get; set; }
		[Column] public DateTime? SLADueDate { get; set; }
	}
    
	[TableName("dbo.TAudits")]
	[PrimaryKey("TIDTAudit")]
	[ExplicitColumns]
    public partial class TAudit : dbconnectionDB.Record<TAudit>  
    {
		[Column] public long TIDTAudit { get; set; }
		[Column] public long? TID { get; set; }
		[Column] public string Process { get; set; }
		[Column] public string Status { get; set; }
		[Column] public DateTime DateAction { get; set; }
	}

    [TableName("dbo.TIDOuts")]
    [PrimaryKey("TIDIDOut")]
    [ExplicitColumns]
    public partial class TIDOut : dbconnectionDB.Record<TIDOut>
    {
        [Column] public long TIDIDOut { get; set; }
        [Column] public string Precinto { get; set; }
        [Column] public DateTime CheckoutDateTime { get; set; }
        [Column] public string Process { get; set; }
        [Column] public string Status { get; set; }
        [Column] public bool Available { get; set; }
        [Column] public int UserID { get; set; }
        [Column] public long PIDID { get; set; }
        [Column] public string SkpBox { get; set; }
        [Column] public string ProcessLocal { get; set; }
        [Column] public string Tula { get; set; }
        [Column] public string ObjectId { get; set; }
        [Column] public string BatchName { get; set; }
        [Column] public string BatchNameSon { get; set; }
        [Column] public string TID { get; set; }
        [Column] public string IronID { get; set; }
        [Column] public string BatchType { get; set; }
        [Column] public long BoxId { get; set; }
        [Column] public string DocId { get; set;}
	}
    
	[TableName("dbo.TIDs")]
	[PrimaryKey("TIDID")]
	[ExplicitColumns]
    public partial class TID : dbconnectionDB.Record<TID>  
    {
		[Column] public long TIDID { get; set; }
		[Column] public string Precinto { get; set; }
		[Column] public DateTime CheckinDateTime { get; set; }
		[Column] public string Process { get; set; }
		[Column] public string Status { get; set; }
		[Column] public string BatchName { get; set; }
		[Column] public string BatchType { get; set; }
		[Column] public bool? Available { get; set; }
		[Column] public long UserID { get; set; }
		[Column] public long PIDID { get; set; }
		[Column] public string StatusStr { get; set; }
        [Column] public DateTime FechaE { get; set; }
        [Column] public string TulaE { get; set; }
        [Column] public int NumeroDeOficinaE { get; set; }
        [Column] public string NombreDeOficinaE { get; set; }
        [Column] public string SitioE { get; set; }
        [Column] public string ObservacionE { get; set; }
    }
    
	[TableName("dbo.Users")]
	[PrimaryKey("UserID")]
	[ExplicitColumns]
    public partial class User : dbconnectionDB.Record<User>  
    {
		[Column] public long UserID { get; set; }
		[Column] public string UserPassword { get; set; }
		[Column] public string UserName { get; set; }
		[Column] public string Name { get; set; }
		[Column] public string UserEmail { get; set; }
		[Column] public DateTime UserCreated { get; set; }
		[Column] public int UserType { get; set; }
		[Column] public bool Available { get; set; }
		//[Column] public int AccesFailedCount { get; set; }
		//[Column] public DateTime? LockOutEndDate { get; set; }
		//[Column] public bool Status { get; set; }
		[Column] public string UserSite { get; set; }
	}
    
	[TableName("dbo.UserTypes")]
	[PrimaryKey("UserType", AutoIncrement=false)]
	[ExplicitColumns]
    public partial class UserType : dbconnectionDB.Record<UserType>  
    {
		[Column("UserType")] public int _UserType { get; set; }
		[Column] public string UserTypeName { get; set; }
	}

	[TableName("dbo.MasterInventory")]
	[PrimaryKey("Id", AutoIncrement = true)]
	[ExplicitColumns]
	public partial class MasterInventory : dbconnectionDB.Record<MasterInventory>
	{
		[Column] public int Id { get; set; }
		[Column] public string ServiceArea { get; set; }
		[Column] public string SubServiceArea { get; set; }
		[Column] public string Financecode { get; set; }
		[Column] public string ItemCode { get; set; }
		[Column] public string InsightValue { get; set; }
	}

	[TableName("dbo.Checkin_Tbl")]
	[PrimaryKey("Id", AutoIncrement = true)]
	[ExplicitColumns]
	public partial class CheckinTbl : dbconnectionDB.Record<CheckinTbl>
	{
		[Column] public int Id { get; set; }
		[Column] public string ServiceArea { get; set; }
		[Column] public string SubServiceArea { get; set; }
		[Column] public string Financecode { get; set; }
		[Column] public string ItemCode { get; set; }
		[Column] public string InsightValue { get; set; }
		[Column] public bool BoxExists { get; set; }
		[Column] public bool Available { get; set; }
		[Column] public int NumofBatches { get; set; }
		[Column] public string SKPBox { get; set; }
		[Column] public long User_ID { get; set; }
		[Column] public DateTime DateTime { get; set; }
		[Column] public bool HoldBox { get; set; }
	}

	[TableName("dbo.TID_Tbl")]
	[PrimaryKey("Id", AutoIncrement = true)]
	[ExplicitColumns]
	public partial class TID_Tbl : dbconnectionDB.Record<TID_Tbl>
	{
		[Column] public int Id { get; set; }
		[Column] public int Checkin_Id { get; set; }
		[Column] public long TID { get; set; }
		[Column] public long User_ID { get; set; }
		[Column] public bool Available { get; set; }
		[Column] public string ItemCode { get; set; }
		[Column] public bool IsDeleted { get; set; }		
	}

	[TableName("dbo.Batch_Label_TBL")]
	[PrimaryKey("Id", AutoIncrement = true)]
	[ExplicitColumns]
	public partial class Batch_Label_TBL : dbconnectionDB.Record<Batch_Label_TBL>
	{
		[Column] public int ID { get; set; }
		[Column] public int CheckinID { get; set; }
		[Column] public long User_ID { get; set; }
		[Column] public bool Available { get; set; }
		[Column] public string Batch_Name { get; set; }
		[Column] public int Batch_Consecutive_Number { get; set; }

	}

	[TableName("dbo.BarcodeLookup")]
	[ExplicitColumns]
	public partial class BarcodeLookup : dbconnectionDB.Record<Batch_Label_TBL>
	{
		[Column] public string Barcode { get; set; }
	}
}
